import 'dart:convert';

extension ListExtension<T> on List<T> {
  void addBetween(value) {
    for (int i = length - 1; i > 0; i--) {
      insert(i, value);
    }
  }

  String toJSON() => jsonEncode(this);

  void replaceWhere(T value, bool Function(T) compareFn) {
    final index = indexWhere(compareFn);
    _exchangeAtIndex(index, value);
  }

  void replace(T value) {
    final index = indexOf(value);
    _exchangeAtIndex(index, value);
  }

  void _exchangeAtIndex(int index, T value) {
    removeAt(index);
    insert(index, value);
  }
}
